#ifndef CALL_CONSTRAINTS_H
#define	CALL_CONSTRAINTS_H

#include "Common.h"

class CallConstraints {
private:

	int lastUnblockTime;
	std::vector<CallConstraintsRule> constraintList; /* list of constraints */
	std::vector<std::string> routePrefixList; /* list of route prefixes */
	std::vector<std::string> emergencyNumberList; /* list of emergency numbers */

	void loadConfig(void);
	bool ruleApplies(CallConstraintsRule c, std::string dialedNumber);
	int getCallsCount(CallConstraintsRule c);
	int getCallsDuration(CallConstraintsRule c);
	bool getBlockAllCalls();
	void setBlockAllOutgoingCalls(bool value);
	void sendEmailNotification(CallConstraintsRule c);
	void saveConstraint(CallConstraintsRule c);
	void hangupOutgoingCalls(void);
	bool callIsEmergency(std::string dialedNumber);
public:
	CallConstraints();
	~CallConstraints();
	void print(int fd);
	void printConcise(int fd);
	int test(std::string dialedNumber);
	void schedCheck();
};

#endif	/* CALL_CONSTRAINTS_H */
